package wgname

import "testing"

/*
	Тест для ожидания группы по имени
*/

type tester struct {
	t  *testing.T
	wn *WgName
}

func TestWgName(t *testing.T) {
	test := &tester{
		t: t,
	}
	test.create()
	test.add()
	test.done()
	test.wn.Wait()
}

// Отпскание имени
func (сам *tester) done() {
	сам.t.Logf("=done=")
	сам.doneGood1()
	сам.doneBad1()
	сам.doneBad1()
}

// Повторное удаление
func (сам *tester) doneBad1() {
	сам.t.Logf("=doneBad1=")
	if err := сам.wn.Done("test"); err == nil {
		сам.t.Errorf("doneBad1(): err==nil")
	}
}

func (сам *tester) doneGood1() {
	сам.t.Logf("=doneGood1=")
	if err := сам.wn.Done("test"); err != nil {
		сам.t.Errorf("doneGood1(): err=%v", err)
	}
}

// Добавление имени в группу
func (сам *tester) add() {
	сам.t.Logf("=add=")
	сам.addGood1()
	сам.addBad1()
}

// Уже есть такое имя
func (сам *tester) addBad1() {
	сам.t.Logf("=addBad1=")
	if err := сам.wn.Add("test"); err == nil {
		сам.t.Errorf("addBad1(): err==nil")
	}
	if len(сам.wn.dictName) != 1 {
		сам.t.Errorf("addBad1(): len dictName != 1")
	}
}

func (сам *tester) addGood1() {
	сам.t.Logf("=addGood1=")
	if err := сам.wn.Add("test"); err != nil {
		сам.t.Errorf("addGood1(): err=%v", err)
	}
	if len(сам.wn.dictName) != 1 {
		сам.t.Errorf("addGood1(): len dictName != 1")
	}
}

// Создание группы ожидания
func (сам *tester) create() {
	сам.t.Logf("=create=")
	сам.wn = NewWgName()
	if сам.wn.dictName == nil {
		сам.t.Errorf("create(): dictName == nil")
	}
	if len(сам.wn.dictName) != 0 {
		сам.t.Errorf("create(): dictName not empty")
	}
	if len(сам.wn.chEnd) != 0 {
		сам.t.Errorf("create(): chEnd not empty")
	}
}
